﻿Imports System.Collections.ObjectModel
Imports System.Windows.Controls
Imports IdeaBlade.Core

Namespace FirstSilverlightApp

  ''' <summary>
  ''' Sample trace subscriber.  You can drop the TraceViewer UserControl onto a page
  ''' to display tracing information from the Silverlight application in a grid.
  ''' </summary>
  ''' <remarks>
  ''' To use the TraceSubscriber: 1) listen for its Publish event, and 2) call StartSubscription()
  ''' to have tracing messages sent to you.  You can also call StopSubscription()
  ''' to temporarily or permanently stop receiving messages.
  ''' </remarks>
  Partial Public Class TraceWindow
	  Inherits UserControl

	Public Sub New()

	  InitializeComponent()

	  _messages = New ObservableCollection(Of TraceMessage)()
	  _subscriber = New TraceSubscriber()
	  AddHandler _subscriber.Publish, AddressOf _subscriber_Publish
	  _subscriber.StartSubscription()

	  _dataGrid.ItemsSource = _messages
	End Sub

	Private Sub _subscriber_Publish(ByVal sender As Object, ByVal e As PublishEventArgs)
	  _messages.Add(e.TraceMessage)
	  If _dataGrid.Columns.Count > 0 Then
		_dataGrid.ScrollIntoView(e.TraceMessage, _dataGrid.Columns(0))
	  End If
	End Sub

	Private _subscriber As TraceSubscriber
	Private _messages As ObservableCollection(Of TraceMessage)
  End Class

End Namespace